//------------------------------------------------------
//
//   ʂQRxp}js[^
//    ʊ̉^vZ
//@@@@T◯֐쓮̏ꍇ
//
//          < eemp2dof.cpp >
//
//   XPS      : ʊ̊JnXʒu
//   XPF      : ʊ̏IXʒu
//   YPS      : ʊ̊JnYʒu
//   YPF      : ʊ̏IYʒu
//   op_time  : Ǝ
//   time     : 
//   PH       : ʊ̏o͓_̈ʒuExEx
//
//     2010. 1.28 쐬  BY ╍
//     2012. 4.24   BY ╍       
//   
//------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "cal.h"
#include "personalio.h" 
#include "mech.h"

void EEMP2DOF(
           double XPS, double XPF, double YPS, double YPF,
		   double DELXP, double DELYP,
		   double op_time, double time,
		   POINT *PH
)
{
	double r,r2,r3,r4,r5, rr, drr, ddrr;    

	if( time < 0 ){
		PH->P.x = XPS;
		PH->DP.x = PH->DDP.x = 0.0;
		PH->P.y = YPS;
		PH->DP.y = PH->DDP.y = 0.0;

		return;
	}
		
	if( time > op_time ){
		PH->P.x = XPF;
		PH->DP.x = PH->DDP.x = 0.0;
		PH->P.y = YPF;
		PH->DP.y = PH->DDP.y = 0.0;

		return;
	}

	r = time/op_time;        // T◯֐
	r2 = r*r;
	r3 = r2*r;
	r4 = r3*r;
	r5 = r4*r;

	rr = 6.0*r5 - 15*r4 + 10*r3;
	drr = (30.0*r4 - 60.0*r3 + 30.0*r2 ) / op_time;
	ddrr = (120.0*r3 - 180.0*r2 + 60.0*r) / op_time / op_time;

	PH->P.x = DELXP * rr + XPS;
	PH->DP.x = DELXP*drr;
	PH->DDP.x = DELXP*ddrr;
	PH->P.y = DELYP*rr + YPS;
	PH->DP.y = DELYP*drr;
	PH->DDP.y = DELYP*ddrr;
}
