//------------------------------------------------------
//
//   ʂQRxp}js[^
//    ʊ̉^vZ
//@@@@T◯֐ɂXL̏ꍇ
//
//          < eemp2dofscan.cpp >
//
//   XPMIN    : XLʊ̍ŏXʒu
//   XPMAX    : XLʊ̍őXʒu
//   YPMIN    : XLʊ̍ŏYʒu
//   YPMAX    : XLʊ̍őYʒu
//   NY       : XLʊY
//   op_timeX : X̃XLƎ
//   op_timeY : ỸXLƎ
//   scan_time: XL
//   time     : 
//   PH       : ʊ̏o͓_̈ʒuExEx
//   PHI      : ʊ̎ppEpxEpx
//
//     2012. 5. 6 쐬  BY ╍
//   
//------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "cal.h"
#include "personalio.h" 
#include "mech.h"

void EEMP2DOFSCAN(
           double XPMIN, double XPMAX, double YPMIN, double YPMAX,
		   int NY,
		   double op_timeX, double op_timeY, 
		   double scan_time,
		   double time,
		   POINT *PH
)
{
	double r,r2,r3,r4,r5, rr, drr, ddrr;    
	int nxy;
	double  timexy, timet, timet2;
	double  op_time;
	double  DELXP, DELYP;
	double  DELXP0, DELYP0;
	double  XPS, YPS;

	DELXP0 = XPMAX - XPMIN;
	DELYP0 = ( YPMAX - YPMIN )/( (double)NY );
	DELYP = -DELYP0;

	if( time < 0 ){
		PH->P.x = XPMIN;
		PH->DP.x = PH->DDP.x = 0.0;
		PH->P.y = YPMAX;
		PH->DP.y = PH->DDP.y = 0.0;

		return;
	}
		
	if( time > scan_time ){
		if( NY - NY/2*2 == 0 )  {
			PH->P.x = XPMAX;
		}
		else {
			PH->P.x = XPMIN;
		}
		PH->DP.x = PH->DDP.x = 0.0;
		PH->P.y = YPMIN;
		PH->DP.y = PH->DDP.y = 0.0;

		return;
	}

	timexy = op_timeX + op_timeY;
	nxy = (int)( time/timexy );
	timet = time - ( (double)nxy )*timexy;
	if( timet>op_timeX ) {
		timet2 = timet - op_timeX;
		op_time = op_timeY;
		YPS = YPMAX - ( (double)nxy )*DELYP0;
		DELXP = 0.0;
		if( nxy - nxy/2*2 == 0 )  {
			XPS = XPMAX;
		}
		else {
			XPS = XPMIN;
		}
	}
	else {
        timet2 = timet;
		op_time  = op_timeX;
		YPS = YPMAX - ( (double)nxy )*DELYP0;
		DELYP = 0.0;
		if( nxy - nxy/2*2 == 0 )  {
			XPS = XPMIN;
			DELXP = DELXP0;
		}
		else {
			XPS = XPMAX;
			DELXP = -DELXP0;
		}
	}

	r = timet2/op_time;        // T◯֐
	r2 = r*r;
	r3 = r2*r;
	r4 = r3*r;
	r5 = r4*r;

	rr = 6.0*r5 - 15*r4 + 10*r3;
	drr = (30.0*r4 - 60.0*r3 + 30.0*r2 ) / op_time;
	ddrr = (120.0*r3 - 180.0*r2 + 60.0*r) / op_time / op_time;

	PH->P.x = DELXP * rr + XPS;
	PH->DP.x = DELXP*drr;
	PH->DDP.x = DELXP*ddrr;
	PH->P.y = DELYP*rr + YPS;
	PH->DP.y = DELYP*drr;
	PH->DDP.y = DELYP*ddrr;
}
