//-----------------------------------------------------
//
//@@KEX|W_@ɂAP̉
//
//               < gauss.cpp >
//
//   NV        : m̐
//   wa[NV][NV]: Ws
//   wb[NV]    : 萔xNg
//   ipw[NV]   : Ɨ̈
//   wk[NV]    : Ɨ̈
//
//      2008. 2.14 쐬 BY ╍
//      2011.10.10  BY ╍
//
//-----------------------------------------------------

#include <math.h>
#include "mech.h"
#include "Pidp4bar_subfunctions.h"

int GAUSS ( double wa[NV][NV], double wb[NV], int ipw[NV], double wk[NV] ) 
{
	double eps = 0.222044604925031308e-15;
	int i, j, k, kr, kq, kqm1, kpivot, kp1, kqp1, nk, nkm1, ier, ng;
	double  aw, amax, pivot;

//------  ------

	ng = NV;
	ier = 1;
	kr = 0;
	for(i=0;i<NV;i++)  {
		wk[i] = 0.0;
	}
	for(j=0;j<NV;j++)  {
		for(i=0;i<NV;i++)  {
			aw = fabs( wa[i][j] );
			if( aw > wk[i] )  wk[i] = aw;
		}
	}
	for(i=0;i<NV;i++)  {
		if( wk[i] <= 0.0 )  wk[i] = 1.0/wk[i];
	}
	eps = eps*( (double)ng )*16.0;

//------- Oi -------

	for(k=0;k<NV;k++)  {
		kq = k - kr +1;
		kqm1 = kq - 1;
		kpivot = kqm1;
		amax = fabs( wa[kqm1][k] )*wk[kqm1];
		if( kqm1 != NV-1 ) {
			for(i=kq;i<NV;i++)  {
				aw = fabs( wa[i][k] )*wk[i];
				if( aw>amax )  {
					kpivot = i;
					amax = aw;
				}
			}
		}
		if( amax<=eps )  {
			kr = kr + 1;
			ipw[k] = -1;
		}
		else {
			ipw[k] = kpivot;
			if( kpivot != kqm1 )  {
				aw = wa[kpivot][k];
				wa[kpivot][k] = wa[kqm1][k];
				wa[kqm1][k] = aw;
				aw = wk[kpivot];
				wk[kpivot] = wk[kqm1];
				wk[kqm1] = aw;
			}
			wa[kqm1][k] = 1.0/wa[kqm1][k];
			if( kqm1 != NV-1 )  {
				pivot = wa[kqm1][k];
				for(i=kq;i<NV;i++)  {
					wa[i][k] = wa[i][k]*pivot;
				}
				if( k != NV-1 )  {
					for(j=kq;j<NV;j++)  {
						if( kpivot != kqm1 )  {
							aw = wa[kpivot][j];
							wa[kpivot][j] = wa[kqm1][j];
							wa[kqm1][j] = aw;
						}
						aw = -wa[kqm1][j];
						kp1 = k + 1;
						for(i=kp1;i<NV;i++)  {
							wa[i][j] = wa[i][j] + aw*wa[i][k];
						}
					}
				}
			}
		}
	}

	if( kr != 0 )  ier = 1000 + kr;

//------ 萔xNg̕ϊ ------

	kr = 0;
	for(k=0;k<NV;k++)  {
		kpivot = ipw[k];
		if( kpivot < 0 )  {
			kr = kr + 1;
		}
		else {
			kq = k - kr;
			if( kq != NV-1 ) {
				if( kpivot != kq )  {
					aw = wb[kpivot];
					wb[kpivot] = wb[kq];
					wb[kq] = aw;
				}
				aw = -wb[kq];
				kqp1 = kq + 1;
				for(i=kqp1;i<NV;i++)  {
					wb[i] = wb[i] + aw*wa[i][k];
				}
			}
		} 
	}

	if( ier != 1 )  return ( ier );

//------ ޑ -------

	if( ng>1 ) {
		for(k=0;k<NV-1;k++)  {
			nk = NV - k - 1;
			nkm1 = nk - 1;
			wb[nk] = wb[nk]*wa[nk][nk];
			aw = -wb[nk];
			for(i=0;i<nk;i++)  {
				wb[i] = wb[i] + aw*wa[i][nk];
			}
		}
	}
	wb[0] = wb[0]*wa[0][0];

	return ( 1 );
}