//------------------------------------------------------------
//
//    @@@@@  lvZ
//
//           < cal.cpp >
//
//
//      2002. 8.14 Created by D.Matsuura
//      2010. 8.21 Improved by N. Iwatsuki
//
//------------------------------------------------------------

#include <stdafx.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "const.h"
#include "cal.h"

//---------------------------------------------------------------
//
//         KEX̏@ɂAP̉@
// 
//              < gauss.cpp >
// 
//      a@     : Ws
//      b       : 萔xNg
//      eps     : x
//      iopt    : 
//      *ip     : s{bgxNg
//      *result : xNg
//      *val    : ͂ꂽ
//      ֐l  : ۂɓ͂ꂽ̌
//
//----------------------------------------------------------------

int GAUSS ( MATRIX a, VECTOR b, double eps, int iopt, VECTOR *ip, VECTOR *result )
{
	VECTOR wk;
	double ueps = 0.222044604925031308e-15;
	double seps;

	double aw, amax, pivot;
	int ier = 0;
	int i, j, k, kr, kp1, kq, kqm1, kqp1, kpivot, nm1, nk, nkm1;

//-----  p[^`FbN  ------

	if( iopt < 0 )
		iopt = abs( iopt );
	if( a.col != a.row || a.col != a.row || ip->size != b.size ){
		printf("gauss error : dimension error.\n");
		return ERROR;
	}
	if( iopt == 0 || iopt >= 3 ){
		printf("gauss error : iopt is illegal.\n");
		return ier;
	}

//------  l̐ݒ  ------

	init_vector( &wk, a.row );

	kr = 0;

	for( i=0; i<a.row; i++ )
		wk.val[i] = 0;

	for( j=0; j<a.row; j++ )
		for( i=0; i<a.row; i++ )
			if( fabs(a.val[i][j]) > wk.val[i] )
				wk.val[i] = fabs( a.val[i][j] );

	for( i=0; i<a.row; i++ )
		if( wk.val[i] != 0 )
			wk.val[i] = 1.0/wk.val[i];

	seps = eps;
	if( eps < 0.0 )
		seps = 16.0*(double)a.row*ueps;

//------  Oi  ------

	for( k=0; k<a.row; k++ ){

		kq = k - kr + 1;
		kqm1 = kq - 1;
		kpivot = kqm1;
		amax = fabs( a.val[kqm1][k] ) * wk.val[kqm1];

		if( kqm1 != a.row ){
			for( k=kq; i<a.row; i++ ){
				aw = fabs( a.val[i][k] )*wk.val[i];
				if( aw > amax ){
					kpivot = i;
					amax = aw;
				}
			}
		}
		if( amax <= seps ){
			kr ++;
			ip->val[k] = 0;
		}
		else{
			ip->val[k] = kpivot;
			if( kpivot != kqm1 ){

				aw = a.val[kpivot][k];
				a.val[kpivot][k] = a.val[kqm1][k];
				a.val[kqm1][k] = aw;

				aw = wk.val[kpivot];
				wk.val[kpivot] = wk.val[kqm1];
				wk.val[kqm1] = aw;
			}
			
			a.val[kqm1][k] = 1.0/a.val[kqm1][k];

			if( kqm1 != a.row ){
				pivot = a.val[kqm1][k];

				for( i=kq; i<a.row; i++ )
					a.val[i][k] *=pivot;

				if( k != a.row ){

					for( j=kq; j<a.row; j++ ){
						if( kpivot != kqm1 ){
							aw = a.val[kpivot][j];
							a.val[kpivot][j] = a.val[kqm1][j];
							a.val[kqm1][j] = aw;
						}
						aw = -a.val[kqm1][j];
						kp1 = k + 1;

						for( i=kp1; i<a.row; i++ )
							a.val[i][j] += aw*a.val[i][k];
					}
				}
			}
		}
	}

	if( kr != 0 )
		ier = 3000 + kr;
	if( iopt != 1 && ier != 0 ){
		printf("gauss error : in cal.h line 253.\n");
		return ERROR;
	}

//------  萔xNg̕ϊ  ------

	kr = 0;
	
	for( k=0; k<a.row; k++ ){

		kpivot = (int)ip->val[k];

		if( kpivot <= 0 ){
			kr ++;
		}
		else{
			kq = k - kr;

			if( kq != a.row ){
				if( kpivot != kq ){
					aw = b.val[kpivot];
					b.val[kpivot] = b.val[kq];
					b.val[kq] = aw;
				}
			}

			aw = -b.val[kq];
			kqp1 = kq + 1;

			for( i=kqp1; i<a.row; i++ )
				b.val[i] += aw * a.val[i][k];

		}
	}

	if( ier != 0 ){
		printf("gauss error : in cal.cpp line 289\n");
		return ERROR;
	}

//------  ޑ  ------

	if( a.row != 1 ){

		nm1 = a.row - 1;

		for( k=0; k<nm1; k++ ){
			nk = a.row - k + 1;
			nkm1 = nk - 1;
			b.val[nk] *= a.val[nk][nk];
			aw = -b.val[nk];

			for( i=0; i<nkm1; i++ )
				b.val[i] += aw*a.val[i][nk];
		}
	}

	b.val[0] *= a.val[0][0];

	return SUCCESS;
}

//---------------------------------------------------------------
//
//       @@@ xNg̏
// 
//              < init_vector.cpp >
// 
//      *vector : xNg
//      size    : xNg̑傫
//      ֐l  : ̐^s
//
//----------------------------------------------------------------

int init_vector( VECTOR *vector, int size )
{
	int i;

	vector->size = size;
	vector->val = (double *)malloc( size*sizeof(double) );

	for( i=0; i<size; i++ )
		vector->val[i] = 0;

	return SUCCESS;
}

//---------------------------------------------------------------
//
//       @@@ s̏
// 
//              < init_matrix.cpp >
// 
//      *matrix : s
//      col     : s̍s
//      row     : s̗
//      ֐l  : ̐^s
//
//----------------------------------------------------------------

int init_matrix( MATRIX *matrix, int col, int row )
{
	int i;

	matrix->col = col;
	matrix->row = row;
	matrix->val = (double **)malloc( col*sizeof(double*));

	for( i=0; i<col; i++ )
		matrix->val[i] = (double *)malloc( row*sizeof(double) );

	return SUCCESS;
}