//------------------------------------------------------------
//
//      @@RsExNg̉Z
//
//           < matrix.cpp >
//
//
//      2002. 8.14 Created by N. Iwatsuki
//
//------------------------------------------------------------

#include <stdafx.h>
#include "matrix.h"

//-------------------------------------------------
//
//   @@@3X3s̍s
//
//       det = b a[3][3]b
//
//    a[3][3]    : s
//    *det       : s
//
//-------------------------------------------------
void DET3( double a[3][3], double *det )
{
	*det = a[0][0] * a[1][1] * a[2][2]
		 + a[0][1] * a[1][2] * a[2][0]
		 + a[0][2] * a[1][0] * a[2][1]
		 - a[0][0] * a[1][2] * a[2][1]
		 - a[0][1] * a[1][0] * a[2][2]
		 - a[0][2] * a[1][1] * a[2][0];
}

//---------------------------------------------
//
//      @3X3s̒萔{
//
//           b[3][3] = gain*a[3][3]
//
//    a[3][3]    : s
//    gain       : 萔
//    b[3][3]    : s
//
//---------------------------------------------
void GM3( double gain, double a[3][3], double b[3][3] )
{
	int i,j;

	for( j=0; j<3; j++ ){
		for( i=0; i<3; i++ ){
			b[i][j] = gain * a[i][j];
		}
	}
}

//---------------------------------------------
//
//
//      @3X1xNg̒萔{
//
//           b = gain*a
//
//    a          : xNg
//    gain       : 萔
//    *b         : xNg
//
//---------------------------------------------
void GV3( double gain, VECTOR3 a, VECTOR3 *b)
{
	b->x = gain * a.x;
	b->y = gain * a.y;
	b->z = gain * a.z;
}

//-------------------------------------------------
//
// @@     @3X3s̋ts
//
//     @b[3][3] = a[3][3]**(-1)
//
//    a[3][3]    : s
//    b[3][3]    : s
//    ֐l     : 0:@ 1:ts񑶍݂
//
//-------------------------------------------------
int IM3( double a[3][3], double b[3][3] )
{
	double det33;

	det33 = a[0][0] * a[1][1] * a[2][2] - a[0][0] * a[1][2] * a[2][1]
		- a[0][1] * a[1][0] * a[2][2] + a[0][1] * a[1][2] * a[2][0]
		+ a[0][2] * a[1][0] * a[2][1] - a[0][2] * a[1][1] * a[2][0];

	if( fabs(det33) <= 1.0e-30 )
		return 1;

	b[0][0] = ( a[1][1] * a[2][2] - a[1][2] * a[2][1] ) / det33;
	b[0][1] = ( a[0][2] * a[2][1] - a[0][1] * a[2][2] ) / det33;
	b[0][2] = ( a[0][1] * a[1][2] - a[0][2] * a[1][1] ) / det33;
	b[1][0] = ( a[1][2] * a[2][0] - a[1][0] * a[2][2] ) / det33;
	b[1][1] = ( a[0][0] * a[2][2] - a[0][2] * a[2][0] ) / det33;
	b[1][2] = ( a[0][2] * a[1][0] - a[0][0] * a[1][2] ) / det33;
	b[2][0] = ( a[1][0] * a[2][1] - a[1][1] * a[2][0] ) / det33;
	b[2][1] = ( a[0][1] * a[2][0] - a[0][0] * a[2][1] ) / det33;
	b[2][2] = ( a[0][0] * a[1][1] - a[0][1] * a[1][0] ) / det33;

	return 0;
}

//-------------------------------------------------
//
// @@     @3X3s̘a
//
//     @c[3][3]  = a[3][3] + b[3][3]
//
//    a[3][3]    : s
//    b[3][3]    : s
//    c[3][3]    : s
//
//-------------------------------------------------
void MAM3( double a[3][3], double b[3][3], double c[3][3] )
{
	int i,j;

	for( j=0; j<3; j++ ){
		for( i=0; i<3; i++ ){
			c[i][j] = a[i][j] + b[i][j];
		}
	}
}

//------------------------------------------------
//
// @@     @3X3s̐
//
//     @c[3][3]  = a[3][3] * b[3][3]
//
//    a[3][3]    : s
//    b[3][3]    : s
//    c[3][3]    : s
//
//-----------------------------------------------
void MPM3 ( double a[3][3], double b[3][3], double c[3][3] )
{
	double wk[3][3];
	int i,j,k;

	for( j=0; j<3; j++ ){
		for( i=0; i<3; i++ ){
			wk[i][j] = 0.0;
		}
	}

	for( i=0; i<3; i++ ){
		for( j=0; j<3; j++ ){
			for( k=0; k<3; k++ ){
				wk[i][j] = wk[i][j] + a[i][k]*b[k][j];
			}
		}
	}

	for( j=0; j<3; j++ ){
		for( i=0; i<3; i++ ){
			c[i][j] = wk[i][j];
		}
	}
}

//--------------------------------------------
//
// @@    @3X3s3X1xNg̐
//
//     @c = a[3][3]*b
//
//    a[3][3]    : s
//    b          : xNg
//    *c    @   : xNg
//
//--------------------------------------------
void MPV3(double M[3][3], VECTOR3 a, VECTOR3 *b)
{
	b->x = M[0][0]*a.x + M[0][1]*a.y + M[0][2]*a.z;
	b->y = M[1][0]*a.x + M[1][1]*a.y + M[1][2]*a.z;
	b->z = M[2][0]*a.x + M[2][1]*a.y + M[2][2]*a.z;
}


//-------------------------------------------------
//
// @@     @3X3s̍
//
//     @c[3][3]  = a[3][3] - b[3][3]
//
//    a[3][3]    : s
//    b[3][3]    : s
//    c[3][3]    : s
//
//-------------------------------------------------
void MSM3( double a[3][3], double b[3][3], double c[3][3] )
{
	int i,j;

	for( j=0; j<3; j++ ){
		for( i=0; i<3; i++ ){
			c[i][j] = a[i][j] - b[i][j];
		}
	}
}


//------------------------------------------
//
// @@     @3X3s̓]u
//
//          b[3][3] = a[3][3]T
//
//    a[3][3]    : s
//    b[3][3]    : ]us
//
//-----------------------------------------
void TM3( double a[3][3], double b[3][3])
{
	double wk[3][3];
	int i,j;

	for( j=0; j<3; j++ ){
		for( i=0; i<3; i++ ){
			wk[j][i] = a[i][j];
		}
	}

	for( j=0; j<3; j++ ){
		for( i=0; i<3; i++ ){
			b[i][j] = wk[i][j];
		}
	}
}


//-------------------------------------------------
//
// @@     @3X1xNg̘a
//
//               c = a + b
//
//    a          : xNg
//    b          : xNg
//    *c    @   : xNg
//
//-------------------------------------------------
void VAV3( VECTOR3 a, VECTOR3 b,  VECTOR3 *c )
{
	c->x = a.x + b.x;
	c->y = a.y + b.y;
	c->z = a.z + b.z;
}


//-------------------------------------------------
//
// @@     @3X1xNg̓
//
//               c = (a , b)
//
//    a          : xNg
//    b          : xNg
//    *c    @   : ϒl
//
//-------------------------------------------------
void VIV3( VECTOR3 a, VECTOR3 b,  double *c )
{
	*c = a.x*b.x + a.y*b.y + a.z*b.z;
}


//----------------------------------------------
//
// @@@3X1xNg̊Oςs̐ςɕϊ
//
//        a*( b[3][3]*x ) = c[3][3]*x
//
//    a          : xNg
//    b[3][3]    : s
//    c  @ @   : s
//
//----------------------------------------------
void VPM3 ( VECTOR3 a, double b[3][3], double c[3][3] )
{
	c[0][0] = a.y * b[2][0] - a.z * b[1][0];
	c[1][0] = a.z * b[0][0] - a.x * b[2][0];
	c[2][0] = a.x * b[1][0] - a.y * b[0][0];
	c[0][1] = a.y * b[2][1] - a.z * b[1][1];
	c[1][1] = a.z * b[0][1] - a.x * b[2][1];
	c[2][1] = a.x * b[1][1] - a.y * b[0][1];
	c[0][2] = a.y * b[2][2] - a.z * b[1][2];
	c[1][2] = a.z * b[0][2] - a.x * b[2][2];
	c[2][2] = a.x * b[1][2] - a.y * b[0][2];
}


//-----------------------------------------------
//
// @@@@@3X1xNg̊O
//
//            c = a*b
//
//    a          : xNg
//    b          : xNg
//    *c    @   : OσxNg
//
//-----------------------------------------------
void VPV3 ( VECTOR3 a, VECTOR3 b, VECTOR3 *c )
{
	VECTOR3 wk;

	wk.x = a.y * b.z - a.z * b.y;
	wk.y = a.z * b.x - a.x * b.z;
	wk.z = a.x * b.y - a.y * b.x;

	*c = wk;
}

//-------------------------------------------------
//
// @@     @3X1xNg̍
//
//               c = a - b
//
//    a          : xNg
//    b          : xNg
//    *c    @   : xNg
//
//-------------------------------------------------
void VSV3( VECTOR3 a, VECTOR3 b,  VECTOR3 *c )
{
	c->x = a.x - b.x;
	c->y = a.y - b.y;
	c->z = a.z - b.z;
}
