//------------------------------------------------------------
//
//   @RsExNg̉ZCN[ht@C
//
//           < matrix.h >
//
//
//      2010. 8.14 Created by N. Iwatsuki
//
//------------------------------------------------------------

#include <stdio.h>
#include <math.h>
#include "mech.h"

#ifndef __MATRIX_H
#define __MATRIX_H

//-------------------------------------------------
//
//   @@@3X3s̍s
//
//       det = b a[3][3]b
//
//    a[3][3]    : s
//    *det       : s
//
//-------------------------------------------------
void DET3( double a[3][3], double *det );
//---------------------------------------------
//
//      @3X3s̒萔{
//
//           b[3][3] = gain*a[3][3]
//
//    a[3][3]    : s
//    gain       : 萔
//    b[3][3]    : s
//
//---------------------------------------------
void GM3( double gain, double a[3][3], double b[3][3] );
//---------------------------------------------
//
//
//      @3X1xNg̒萔{
//
//           b = gain*a
//
//    a          : xNg
//    gain       : 萔
//    *b         : xNg
//
//---------------------------------------------
void GV3( double gain, VECTOR3 a, VECTOR3 *b);
//-------------------------------------------------
//
// @@     @3X3s̋ts
//
//     @b[3][3] = a[3][3]**(-1)
//
//    a[3][3]    : s
//    b[3][3]    : s
//    ֐l     : 0:@ 1:ts񑶍݂
//
//-------------------------------------------------
int IM3( double a[3][3], double b[3][3] );
//-------------------------------------------------
//
// @@     @3X3s̘a
//
//     @c[3][3]  = a[3][3] + b[3][3]
//
//    a[3][3]    : s
//    b[3][3]    : s
//    c[3][3]    : s
//
//-------------------------------------------------
void MAM3( double a[3][3], double b[3][3], double c[3][3] );
//------------------------------------------------
//
// @@     @3X3s̐
//
//     @c[3][3]  = a[3][3] * b[3][3]
//
//    a[3][3]    : s
//    b[3][3]    : s
//    c[3][3]    : s
//
//-----------------------------------------------
void MPM3( double a[3][3], double b[3][3], double c[3][3] );
//--------------------------------------------
//
// @@    @3X3s3X1xNg̐
//
//     @c = a[3][3]*b
//
//    a[3][3]    : s
//    b          : xNg
//    *c    @   : xNg
//
//--------------------------------------------
void MPV3(double M[3][3], VECTOR3 a, VECTOR3 *b);
//-------------------------------------------------
//
// @@     @3X3s̍
//
//     @c[3][3]  = a[3][3] - b[3][3]
//
//    a[3][3]    : s
//    b[3][3]    : s
//    c[3][3]    : s
//
//-------------------------------------------------
void MSM3( double a[3][3], double b[3][3], double c[3][3] );
//------------------------------------------
//
// @@     @3X3s̓]u
//
//          b[3][3] = a[3][3]T
//
//    a[3][3]    : s
//    b[3][3]    : ]us
//
//-----------------------------------------
void TM3( double a[3][3], double b[3][3]);
//-------------------------------------------------
//
// @@     @3X1xNg̘a
//
//               c = a + b
//
//    a          : xNg
//    b          : xNg
//    *c    @   : xNg
//
//-------------------------------------------------
void VAV3( VECTOR3 a, VECTOR3 b, VECTOR3 *c );
//-------------------------------------------------
//
// @@     @3X1xNg̓
//
//               c = (a , b)
//
//    a          : xNg
//    b          : xNg
//    *c    @   : ϒl
//
//-------------------------------------------------
void VIV3( VECTOR3 a, VECTOR3 b,  double *c );
//----------------------------------------------
//
// @@@3X1xNg̊Oςs̐ςɕϊ
//
//        a*( b[3][3]*x ) = c[3][3]*x
//
//    a          : xNg
//    b[3][3]    : s
//    c  @ @   : s
//
//----------------------------------------------
void VPM3( VECTOR3 a, double b[3][3], double c[3][3] );
//-----------------------------------------------
//
// @@@@@3X1xNg̊O
//
//            c = a*b
//
//    a          : xNg
//    b          : xNg
//    *c    @   : OσxNg
//
//-----------------------------------------------
void VPV3( VECTOR3 a, VECTOR3 b, VECTOR3 *c );
//-------------------------------------------------
//
// @@     @3X1xNg̍
//
//               c = a - b
//
//    a          : xNg
//    b          : xNg
//    *c    @   : xNg
//
//-------------------------------------------------
void VSV3( VECTOR3 a, VECTOR3 b, VECTOR3 *c );

#endif
