//------------------------------------------------------------
//
//    @@@@@\wvZCN[ht@C
//
//           < mech.h >
//
//
//      2002. 8.14 쐬 by Y
//      2003.10.13  by Y
//      2008. 1.12  by Y
//      2008. 1.14  by ╍
//      2010. 8.21  by ╍
//
//------------------------------------------------------------

#ifndef _MECH_H
#define _MECH_H

#include "const.h"

// px^iʒuExExj
typedef struct ANGLE{
	double the;
	double dthe;
	double ddthe;
} ANGLE;

// xNg^
typedef struct VECTOR3{
	double x;
	double y;
	double z;
} VECTOR3;

// |Cg^
typedef struct POINT{
	VECTOR3 P;
	VECTOR3 DP;
	VECTOR3 DDP;
} POINT;

// POSITION^iPOINT^Ɠj
typedef POINT POSITION;

// VARIABLE^
typedef struct VARIABLE{
	double v;
	double dv;
	double ddv;
} VARIABLE;

// pp^
typedef struct POSTURE{
	VECTOR3 RPY;
	VECTOR3 DRPY;
	VECTOR3 DDRPY;
} POSTURE;

// px^
typedef struct AVELOCITY{
	VECTOR3 OMG;
	VECTOR3 DOMG;
} AVELOCITY;

//-----------------------------------------------------------
//   ]߂̉^
//-----------------------------------------------------------
void crank_input( POINT j1, double l, ANGLE theta, ANGLE phi, POINT *j2 );
//-----------------------------------------------------------
//   i߂̉^
//-----------------------------------------------------------
void slider_input( POINT pg, double l, ANGLE psig,  VARIABLE s, double gsi, double eta, POINT *jp, POINT *jc );
//-----------------------------------------------------------
//   Q_ԂԐ̐p
//-----------------------------------------------------------
int segment_angle( POINT j1, POINT j2, ANGLE *angle );
//-----------------------------------------------------------
//   ]΋ŐڑꂽQA߂̉^
//-----------------------------------------------------------
int  RRR_links( POINT j1, POINT j2, double l1, double l2, int minv, POINT *j3 );
//-----------------------------------------------------------
//   i΋Ɠ̉]΋ŐڑꂽQA߂̉^
//-----------------------------------------------------------
int PRR_links( POINT jr, double l, POINT pg, ANGLE psig, double gsi, double eta, int minv, VARIABLE *s, POINT *jp, POINT *jb );
//-----------------------------------------------------------
//   ߂̊pψʁiߏ̂Q΋ԂԐ̐pj
//-----------------------------------------------------------
int link_angle( POINT j1, POINT j2, ANGLE *angle );
//-----------------------------------------------------------
//   Ԑߏ̕`_̉^
//-----------------------------------------------------------
int coupler_point( POINT j1, POINT j2, double gsi, double eta, POINT *jc, ANGLE *angle );
//-----------------------------------------------------------
//   [pɂWϊs
//---------------------------------------------------------
void RollTT ( double Roll_angle, double TT[3][3] );
//-----------------------------------------------------------
//   sb`pɂWϊs
//---------------------------------------------------------
void PitchTT ( double Pitch_angle, double TT[3][3] );
//-----------------------------------------------------------
//   [pɂWϊs
//---------------------------------------------------------
void YawTT ( double Yaw_angle, double TT[3][3] );
//-----------------------------------------------------------
//   [Esb`E[pWϊs߂
//---------------------------------------------------------
void RPYTT ( POSTURE A, double TT[3][3], double dTT[3][3], double ddTT[3][3] );
//-----------------------------------------------------------
//     [Esb`E[ppxEpxxNg߂
//-----------------------------------------------------------
void RPYAVELO ( POSTURE RPY_ANGLES, AVELOCITY *AVELO );
//-----------------------------------------------------------
//   Wϊs񂩂烍[Esb`E[p߂
//-----------------------------------------------------------
void TTRPY ( double TT[3][3], double dTT[3][3], double ddTT[3][3], POSTURE *RPY_ANGLES  );
//-----------------------------------------------------------
//   WϊsɊÂRWϊ
//-----------------------------------------------------------
void TRANS( VECTOR3 PM, POSITION P0,
            double TT[3][3], double dTT[3][3], double ddTT[3][3],
			POSITION *PF );
//-----------------------------------------------------------
//  ԉ]߂̉^
//-----------------------------------------------------------

void s_crank_input( POSITION j1, 
				    double TT1[3][3], double dTT1[3][3], double ddTT1[3][3],
				    ANGLE theta,
				    VECTOR3 j2m,
				    double TT12[3][3],
						POSITION *j2, 
						double TT2[3][3], double dTT2[3][3], double ddTT2[3][3] );
//-----------------------------------------------------------
//      |i|΋QA߂̉^
//-----------------------------------------------------------
int s_SPS_links ( POSITION s1, POSITION s2,
				   double p0,
				   POSITION *p,
				   VARIABLE *the );
//-----------------------------------------------------------
//      ||i΋QA߂̉^
//-----------------------------------------------------------
int s_SSP_links ( POSITION s1,
                   double rs,
				   POSITION g,
                   double TLT[3][3], double dTLT[3][3], double ddTLT[3][3], 
                   VECTOR3  s2p,
				   int minv,
				   VARIABLE *the,
				   POSITION *p,
				   POSITION *s2 );
//-----------------------------------------------------------
//   ʒuxNg̏
//-----------------------------------------------------------
void init_joint( POSITION *j );
//-----------------------------------------------------------
//   ʒuxNg̐̐ݒ
//-----------------------------------------------------------
void set_locate( double x, double y, double z, POINT *j );
//-----------------------------------------------------------
//   ʒuxNg̍xNg
//-----------------------------------------------------------
void get_diff( POINT j1, POINT j2, POINT *d );
//-----------------------------------------------------------
//   pψʍ\̂̐ݒ
//-----------------------------------------------------------
void make_angle( double the, double dthe, double ddthe, ANGLE *angle );

#endif